<!-- markdownlint-disable MD024 -->

# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## [Unreleased]

### Added

### Changed

### Deprecated

* `tm_run_query` will be removed around 0.3. Please use `tm_get_tasks` instead.
* `tm_query_id_equals` will be removed around 0.3. Please use `tm_get_task` directly.

### Removed

### Fixed

### Security

## [0.2] - 2019-03-26

First ever [keepachangelog](https://keepachangelog.com/)-ed release.

### Added

#### Added desktop browser end-to-end test suite

  See `test/e2e/index.test.js`. Right now there are basic tests for adding a task, editing, querying.

#### [issue 23](https://bitbucket.org/tsieprawski/taskman/issues/23): Editing task web page

  At `/edit/N.html`, or by going into task page and clicking `Edit` from the top bar,
  is a form to edit the task's properties. As for `/add.html` form, available fields
  are name, status and description. Works both for JS (which actually calls `POST /api/modify`) and non-JS.

  Additionally in JS page is added to history API, after opening the page and after submitting
  (with submitted values and/or error).

#### [issue 22](https://bitbucket.org/tsieprawski/taskman/issues/22): Adding task web page

  At `/add.html`, or by going into `Add a task` from any page's top bar, adding task page
  contains a form to... Add a task. Currently the form contains fields for name (required),
  status (required with default value) and textarea for description. Works both for JS
  (which actually calls `POST /api/add`) and non-JS.

  Additionally in JS page is added to history API, after opening the page and after submitting
  (with submitted values and/or error).

#### [issue 25](https://bitbucket.org/tsieprawski/taskman/issues/25): Date created/updated

  Task contains creation date and calculated last update date. History entries contain their dates of creation.
  Tasks migrated from database v1 will be given creation date of "now".

* `libtm` API-s: `tm_task_get_date_created`, `tm_task_get_date_updated`, `tm_task_diff_get_date`,
  `tm_query_date_created_after`, `tm_query_date_created_before`,  `tm_query_date_updated_after`,
  `tm_query_date_updated_before`.

* `tm` prints creation and last updated date in `tm print`, and `tm q`/`tm m`/`tm r` have filters
  for date created/updated before/after (`dc`/`dcgt`/`dclt` & `du`/`dugt`/`dult`, or `date-created`/
  `date-created-after`/`date-created-before` & `date-updated`/`date-updated-after`/`date-updated-before`).

  "After" and "before" ranges are inclusive for provided date formats (effectively "after" means `>=`
  and "before" means "< first greater date that does not match"). Bare filter is shortcut for "after" and "before"
  at once.

  So for example "before 1970" includes whole 1970 year from `Jan 01 00:00:00` to `Dec 31 23:59:59`.
  And "before 1970-01" means from `Jan 01 00:00:00` to `Jan 31 23:59:59`.

  Recognized formats and how they are parsed:

  | Format                | After?                      | Before?                                 |
  | --------------------- | --------------------------- | --------------------------------------- |
  | `1970`                | `1970-01-01 00:00:00`       | `1971-01-01 00:00:00` (next year)       |
  | `1970-01`             | `1970-01-01 00:00:00`       | `1970-02-01 00:00:00` (next month)      |
  | `1970-01-01`          | `1970-01-01 00:00:00`       | `1970-01-02 00:00:00` (next day*)       |
  | `1970-01-01 01`       | `1970-01-01 01:00:00`       | `1970-01-01 02:00:00` (next hour)       |
  | `1970-01-01 01:01`    | `1970-01-01 01:01:00`       | `1970-01-01 01:02:00` (next minute)     |
  | `1970-01-01 01:01:01` | `1970-01-01 01:01:01`       | `1970-01-01 01:01:02` (next second**)   |
  | `now`                 | This very date time.        | Yeah.                                   |
  | `today`               | Today 00:00:00              | Tomorrow 00:00:00                       |
  | `monday`              | Next*** Monday 00:00:00     | Tuesday after next Monday 00:00:00      |
  | `tuesday`             | Next*** Tuesday 00:00:00    | Wednesday after next Tuesday 00:00:00   |
  | `wednesday`           | Next*** Wednesday 00:00:00  | Thursday after next Wednesday 00:00:00  |
  | `thursday`            | Next*** Thursday 00:00:00   | Friday after next Thursday 00:00:00     |
  | `friday`              | Next*** Friday 00:00:00     | Saturday after next Friday 00:00:00     |
  | `saturday`            | Next*** Saturday 00:00:00   | Sunday after next Saturday 00:00:00     |
  | `sunday`              | Next*** Sunday 00:00:00     | Monday after next Sunday 00:00:00       |

  * This takes into account leap years, so "before 1972-02-29" is whole 1972-02-29 and before.

  ** Because of how "before" is defined and implemented, leap seconds are counted in.
  For a year with leap second, "before 23:59:59" actually counts in 23:59:60.
  This is because at the time of writing this there was not a way to reliably detect when are leap
  seconds, and the trade-off of counting 2 possible "date time seconds" is fine enough.

  *** If today it is requested day, then today, otherwise the very next one.
  If you want Monday and today is Monday, then it is today. If today is Tuesday and you want Monday,
  then it is in 6 days.

* Endpoint `GET /api/task/N` returns new integer properties `date-created` and `date-updated`
  with UNIX timestamp. Also `history` entries contain `date`.

* Endpoints `GET/POST /api/query`, `POST /api/remove` and `POST /api/modify` accept string filters
  `date-created-after`, `date-created-before`, `date-updated-after`, `date-updated-before`
  with same formats as `tm` counterparts.

* Task page contains "Date Created" and "Date Updated" properties, also "Date" appears in history
  entries.

* Index page contains new filters for date created/updated before/after.

#### [issue 54](https://bitbucket.org/tsieprawski/taskman/issues/54): Database upgrade

  Database automatically upgrades to past-task history introduction format (so called "v2", as opposite to "v1"
  before) upon startup.

  Task name and descriptions are migrated. ID-s are not guaranteed to match!

#### [issue 17](https://bitbucket.org/tsieprawski/taskman/issues/17): Status property

  New task property - status. By default task's status is "new". There is no predefined or sanctioned list
  of possible status values yet.

* `libtm` API-s: `tm_task_get_status`, `tm_task_set_status`, `tm_task_arr_set_status` & `tm_query_status_contains`;
* `tm add` and `tm modify` have new modifier `s` (or `status`);
* `tm modify`, `tm query` and `tm remove` have new filter `s` (or `status`) that matches any string within task's status;
* Endpoint `GET /api/task/N` returns additional `status` property.

#### [issue 16](https://bitbucket.org/tsieprawski/taskman/issues/16): Support for task history

  Internally history entries contain row ID, name and value of the property recorded - no date.
  Current task properties are retrieved from newest ones. Technically it is possible
  to get state of a task at time of any entry, but this is the talk of the future.

  Right now this supports only (no surprises) name and description of a task. Because
  there are no more properties at all.

* New `libtm` API-s for manipulating a single task.

  `tm_get_task_diffs`, `tm_task_diff_free`, `tm_task_diff_arr_free`, `tm_task_diff_get_id`,
  `tm_task_diff_get_task`, `tm_task_diff_get_name` & `tm_task_diff_get_value` retrieve
  history entries.

  These are equivalent:

```c
tm *tm = 0;
tm_task *task = 0;
unsigned int id = 1;

tm_get_task(tm, id, task);
tm_modify_task(tm, task);
tm_remove_task(tm, task);
tm_add_task(tm, task);

tm_task **arr = 0;
unsigned int len = 0;
tm_query *query = 0;

tm_query_id_equals(tm, id, &query);
tm_get_tasks(tm, query, &arr, &len);
tm_modify_tasks(tm, arr, len);
tm_remove_tasks(tm, arr, len);
tm_add_tasks(tm, arr, len);
```

* `tm` has new command to print a single task by its ID.
  Additionally task's history is printed "smartly", as not simply name-value
  pairs are printed but actual change to previous state:

  * that property value was added, especially after creation of the task,
  * that property value changed from X to X,
  * that property value was removed.

  `tm print 1` is equivalent to `tm query id 1`.

* `tms` has new endpoint `GET /api/task/1` for getting a single task.
  Additionally it contains task's history in similar manner as for `tm` - changes.

```http
GET /api/task/1 HTTP/1.0
...

HTTP/1.1 200 OK
...

{
    "name": "A name",
    ...,
    "history": [
        {"type": "add", "name": "name", "value": "Aaa"},
        {"type": "remove", "name": "name", "value": "Aaa"},
        {"type": "change", "name": "name", "value": "Aaa", "new-value": "Bbb"},
        ...
    ]
}
```

* Task page contains a simple `<table/>` with the history, both via `GET /task/N.html`
  and opening the task page via javascript.

#### [issue 51](https://bitbucket.org/tsieprawski/taskman/issues/51): New `/task/N.html` page

  For showing a single task.

#### [issue 24](https://bitbucket.org/tsieprawski/taskman/issues/24): New `/index.html` page

  For querying tasks with basic HTML form and result table. Backed by a basic templating engine
  (`tpl_lib` + `tpl_to_c` tools) that generates C code, that generates output page.

#### [issue 8](https://bitbucket.org/tsieprawski/taskman/issues/8): Task descriptions

  Examples:

* `tm a Name d Description` creates a task named `Name` with description `Description`.
  `d` is same as `description` name.
* `tm q description Description` gets queries with description matching glob `*Description*`.
* `tm r description Description` removes queries with description matching glob `*Description*`.
* `tm m description Description -- description Newdescription` filters by description
   and changes the description in such tasks;
* `POST /add` and `POST /modify` accept `description` modifier.
* `POST /query`, `POST /modify` and `POST /remove` accept `description-equals` filter.
* `tms`' HTML supports adding and modifying tasks by description, and querying where description
  is one of columns.

### Changed

* In branch `bugfix/rename-tm-to-tm-lib` C struct name `tm` was renamed to `tm_lib`
  to prevent conflict with `time.h'`-s `struct tm`.

  This means all API-s related having `tm *` as parameter now use `tm_lib *`.

* [issue 17](https://bitbucket.org/tsieprawski/taskman/issues/17): Index page no longer contains
  description column, but status.

  Index page no longer contains description column, but status.

#### [issue 16](https://bitbucket.org/tsieprawski/taskman/issues/16): Refactored sqlite tables

  Also output of `tm query` changed. Description is no longer printed.
  Use new `tm print [id]` to get single task's description.

#### [issue 24](https://bitbucket.org/tsieprawski/taskman/issues/24): Changes to endpoints

  Moved all `tms`' RPC endpoints from `/` to `/api/`, and additionally `/index.html` to `/other.html`

  Additionally changed request and response syntax of `POST /api/query`.

* Request (which becomes an object) has added possibility to provide query options via `opts`.
  Right now only `show-column-description` is supported and results in 3rd column to be added
  to query results.
* Response (which also becomes an object) now contains column names, guaranteed to
  be in every result item.

#### [issue 51](https://bitbucket.org/tsieprawski/taskman/issues/51): Changed response syntax

  Changed response syntax of `POST /api/query` again. ID and name columns are always present, thus they are
  implicit.

#### Syntax of `api/query`

Before:

```http
POST /api/query HTTP/1.0
...

{
    "name-contains": "aaa"
}


HTTP/1.1 200 OK
...

[
    {"id": 1, "name": "A name"},
    {"id": 2, "name": "B name"},
    ...
]
```

After:

```http
POST /api/query HTTP/1.0
...

{
    "filters": {
        "name-contains": "aaa"
    }
}


HTTP/1.1 200 OK
...

{
    "columns": [],
    "items": [
        {"id": 1, "name": "A name"},
        {"id": 2, "name": "B name"},
        ...
    ]
}
```

#### [issue 8](https://bitbucket.org/tsieprawski/taskman/issues/8): Changed argument parsing

  In `tm` to be both prepared for any future custom fields in tasks, have the ability to add/modify
  tasks with something more than a name,
  and for the syntax to be more unambiguous and consistent (`tm m n X -- n Y` is,
  whereas `tm m -n X -n Y` is not).

  For arguments related to filtering and modifying, instead of `-s` and `--long`
  explicit key+value pairs will be used.
  `-d` stays the same, `-i` becomes `id`, `-n` becomes `name`. `tm a` and `tm m` now accept
  modifiers `name` and `description`. `tm q`, `tm r` and `tm m` accept filters `id` and `name`.

Upgrading:

| From                                 | To                                      |
| ------------------------------------ | --------------------------------------- |
| `tm q -i 1 -n 2`                     | `tm q i 1 n 2`                          |
| `tm q --id 1 --name 2`               | `tm q id 1 name 2`                      |
| `tm query -i 1 -n 2`                 | `tm query i 1 n 2`                      |
| `tm query --id 1 --name 2`           | `tm query id 1 name 2`                  |
| `tm r -i 1 -n 2`                     | `tm r i 1 n 2`                          |
| `tm r --id 1 --name 2`               | `tm r id 1 name 2`                      |
| `tm remove -i 1 -n 2`                | `tm remove i 1 n 2`                     |
| `tm remove --id 1 --name 2`          | `tm remove id 1 name 2`                 |
| `tm m -i 1 -n 2 Newname`             | `tm m i 1 n 2 -- n Newname`             |
| `tm m --id 1 ---name 2 Newname`      | `tm m id 1 name 2 -- name Newname`      |
| `tm modify -i 1 -n 2 Newname`        | `tm modify i 1 n 2 -- n Newname`        |
| `tm modify --id 1 ---name 2 Newname` | `tm modify id 1 name 2 -- name Newname` |

#### [issue 8](https://bitbucket.org/tsieprawski/taskman/issues/8): Changed syntax of `POST /modify`

* `query` becomes `filters`;
* `args` becomes `modifiers`.

### Deprecated

* `tm_run_query` will be removed around 0.3. Please use `tm_get_tasks` instead.
* `tm_query_id_equals` will be removed around 0.3. Please use `tm_get_task` directly.

### Removed

### Fixed

### Security

## 0.1 - 2018-09-101

Everything was added.
