/*
 * Copyright (c) 2018 Tomasz Sieprawski
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 **/

#ifndef HAVE_SUBPROCESS
#define HAVE_SUBPROCESS

typedef struct subprocess subprocess;
typedef struct subprocess_partial_stream subprocess_partial_stream;

struct subprocess;
struct subprocess_partial_stream;

int subprocess_new(char **argv, char **, int, int, subprocess **);
int subprocess_free(subprocess **);
int subprocess_kill(subprocess *, int);
int subprocess_wait(subprocess *, unsigned int);

int subprocess_read_output(subprocess *, unsigned int,
    subprocess_partial_stream **);
int subprocess_read_error(subprocess *, unsigned int,
    subprocess_partial_stream **);

int subprocess_partial_stream_free(subprocess_partial_stream **);

int subprocess_partial_stream_get_for(subprocess_partial_stream *, unsigned int, char **);
int subprocess_partial_stream_get_until(subprocess_partial_stream *, char,
    unsigned int *, char **);
int subprocess_partial_stream_cmp(subprocess_partial_stream *, unsigned int, char *);
int subprocess_partial_stream_skip_for(subprocess_partial_stream *, unsigned int);
int subprocess_partial_stream_skip_until(subprocess_partial_stream *, char c);

#endif
