/*
 * Copyright (c) 2018 Tomasz Sieprawski
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 **/
#ifndef HAVE_TPL
#define HAVE_TPL

typedef int (*tpl_tag_f)(char **, unsigned int *, void *, char *);
typedef int (*tpl_enter_f)(char **, unsigned int *, void *, char *);
typedef int (*tpl_next_f)(char **, unsigned int *, void *);
typedef void (*tpl_leave_f)(char **, unsigned int *, void *);
typedef int (*tpl_format_f)(tpl_tag_f, tpl_enter_f, tpl_next_f,
    tpl_leave_f, void *, unsigned int *, char **);

int tpl_tag(char **, unsigned int *, tpl_tag_f, void *, char *);
int tpl_enter(char **, unsigned int *, tpl_enter_f, void *, char *);
int tpl_next(char **, unsigned int *, tpl_next_f, void *);
int tpl_leave(char **, unsigned int *, tpl_leave_f, void *);

int tpl_append(char **, unsigned int *, char *, unsigned int);
int tpl_appende(char **, unsigned int *, char *, unsigned int);


#endif
