/*
 * Copyright (c) 2018 Tomasz Sieprawski
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 **/

#ifndef HAVE_TM_TEST_COMMON
#define HAVE_TM_TEST_COMMON

char tm_dir[16];
void *LAST_1_MINUTE;

void run_with_args(char **, unsigned int, char *, unsigned int, char *, unsigned int);
void expect_usage(char **, unsigned int);

void do_add(char *, unsigned int, ...);
void do_remove(int, unsigned int, ...);
void do_modify(int, unsigned int, unsigned int, ...);
void do_query(char *, unsigned int, ...);
void do_print(int, unsigned int, unsigned int, ...);

void do_add_dbfile(char *, char *, unsigned int, ...);
void do_remove_dbfile(char *, int, unsigned int, ...);
void do_modify_dbfile(char *, int, unsigned int, unsigned int, ...);
void do_query_dbfile(char *, char *, unsigned int, ...);
void do_print_dbfile(char *, int, unsigned int, unsigned int, ...);

void init_folder(void);
void clear_folder(void);

void cache_timezone(void);
void restore_timezone(void);

#endif
