/*
 * Copyright (c) 2018 Tomasz Sieprawski
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 **/

#ifndef HAVE_TMS_INC
#define HAVE_TMS_INC

#include <mongoose.h>
#include <tm.h>

extern tm_lib *taskman;

void send_error(struct mg_connection *, struct http_message *, int);
void send_ok(struct mg_connection *, struct http_message *, char *,
    unsigned int, char *);
void send_303(struct mg_connection *, struct http_message *, char *);
void send_304(struct mg_connection *, struct http_message *, char *);

void do_api_add(struct mg_connection *, struct http_message *);
void do_api_modify(struct mg_connection *, struct http_message *);
void do_api_query(struct mg_connection *, struct http_message *);
void do_api_ping(struct mg_connection *, struct http_message *);
void do_api_remove(struct mg_connection *, struct http_message *);
void do_api_task(struct mg_connection *, struct http_message *);

void do_add_html(struct mg_connection *, struct http_message *);
void do_edit_html(struct mg_connection *, struct http_message *);
void do_index_html(struct mg_connection *, struct http_message *);
void do_task_html(struct mg_connection *, struct http_message *);

void do_datepicker_min_css(struct mg_connection *, struct http_message *);
void do_lib_js(struct mg_connection *, struct http_message *);
void do_other_html(struct mg_connection *, struct http_message *);
void do_other_js(struct mg_connection *, struct http_message *);

int extract_id(char *, unsigned int, int, unsigned long *);

void extract_post_ul(struct http_message *, char *, unsigned long **);
void extract_post_t(struct http_message *, char *, time_t **);
void extract_post_s(struct http_message *, char *, char **);

#endif
