/*
 * Copyright (c) 2018 Tomasz Sieprawski
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 **/

#include <stdio.h>
#include <string.h>
#include <signal.h>

#include <tms.h>

int extract_id(char *url, unsigned int url_len, int ends_with_dothtml, unsigned long *pid)
{
    char *endptr = 0;
    char *tmp;
    long ret;
    int ret2 = 0;
    unsigned int i;
    unsigned int int_len = url_len;

    if (1 == ends_with_dothtml)
    {
        int_len -= 5;
    }

    for (i = 0; i < int_len; i++)
    {
        if ('0' > url[i] || '9' < url[i])
        {
            return 0;
        }
    }
    if (1 == ends_with_dothtml && 0 != strncmp(".html", url + url_len - 5, 5))
    {
        return 0;
    }

    tmp = (char *)malloc(sizeof(char) * (int_len + 1));
    memcpy(tmp, url, int_len);
    tmp[int_len] = 0;

    errno = 0;
    ret = strtol(tmp, &endptr, 10);
    if (0 == errno && 0 == (*endptr) && 0 <= ret)
    {
        ret2 = 1;
        *pid = (unsigned long) ret;
    }
    free(tmp);
    return ret2;
}

void extract_post_ul(struct http_message *hm, char *name, unsigned long **ppfilter)
{
    char tmp[1024];
    if (0 != mg_get_http_var(&(hm->body), name, tmp, sizeof(tmp)))
    {
        (*ppfilter) = (unsigned long *)malloc(sizeof(unsigned long));
        (**ppfilter) = atol(tmp);
    }
}

void extract_post_t(struct http_message *hm, char *name, time_t **ppfilter)
{
    char tmp[1024];
    if (0 != mg_get_http_var(&(hm->body), name, tmp, sizeof(tmp)))
    {
        (*ppfilter) = (time_t *)malloc(sizeof(time_t));
        (**ppfilter) = atol(tmp);
    }
}

void extract_post_s(struct http_message *hm, char *name, char **pfilter)
{
    char tmp[1024];
    if (0 != mg_get_http_var(&(hm->body), name, tmp, sizeof(tmp)))
    {
        (*pfilter) = strdup(tmp);
    }
}
