/*
 * Copyright (c) 2018 Tomasz Sieprawski
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 **/

#ifndef HAVE_TMS_TEST_COMMON
#define HAVE_TMS_TEST_COMMON

#include <tpl.h>

extern void *DONT_CARE;

enum date_verifier_type
{
    DVT_NULL,
    DVT_LAST_1_MINUTE,
    DVT_AFTER,
    DVT_BEFORE
};

typedef struct date_verifier date_verifier;
struct date_verifier
{
    enum date_verifier_type type;
    time_t value;
};

void build_body_from_template(tpl_format_f, tpl_tag_f, tpl_enter_f, tpl_next_f, tpl_leave_f,
    void *, char **, unsigned int *);

void expect_http_get(char *, char *, int, unsigned int, char **, char *);
void expect_http_post(char *, char *, char *, int, unsigned int, char **, char *);

void expect_process_usage(char **, int);
void expect_process_started_and_died(char **);

void expect_process_started(char **, unsigned int *);
void expect_process_started_accesslog(char **, unsigned int *);
void expect_process_died(char *);
void expect_process_no_output(void);
void expect_process_output_accesslog(char *, char *, char *, unsigned int, unsigned int);

void do_add(char *, unsigned int, unsigned int, ...);
void do_modify(char *, unsigned int, int, unsigned int, unsigned int, ...);
void do_query(char *, unsigned int, unsigned int, unsigned int, unsigned int, unsigned int, ...);
void do_remove(char *, unsigned int, int, unsigned int, ...);

typedef struct history_entry history_entry;
struct history_entry
{
    char *type;
    char *name;
    char *value;
    char *new_value;
    date_verifier *date;
};

void do_task(char *, unsigned int, char *, char *, char *, char *,
	date_verifier *, date_verifier *, unsigned int, history_entry **);
void do_task_get_date_updated(char *, unsigned int, char *, time_t *);

#endif
